;=====Eiba user interface / Version 2.0======17/06/03==
;	ra1,ra0 - sdata, sclock
;	rb0 to rb7	keyboard inputs
;	internal clock
;	standard crystal 16.000 MHz XT - .25us pe instructiune
;	Program realizat de Ing. Bergthaller Iulian-Alexandru 
;------------------------------------------------------------
;------------------------------------------------------------
;	configure programmer
	list	p=16f84;f=inhx8m
	#INCLUDE P16F84.INC
_CP_OFF	equ	H'3FFF'	      ;code protect off
_PwRTE_ON	equ	H'3FFF' 		;Power on timer on
_wDT_OFF	equ	H'3FFB'		;watch dog timer off
_XT_OSC	equ	H'3FFD'		;crystal oscillator
	__CONFIG       _CP_OFF & _PwRTE_ON & _wDT_OFF & _XT_OSC

;------------------------------------------------------------
;      cpu init
count1	equ	0C
count2	equ	0D
count3	equ	0E
count4	equ	0F
count5	equ	10
bug		equ	11
transo	equ	12
ratb		equ	13
paru		equ	14
clone		equ	15
cnt1		equ	16
eepadr0	equ	17
eepadr1	equ	18
eprdta	equ	19
;------------------------------------------------------------
#DEFINE irec	PORTA,2
#DEFINE enable	PORTA,3
#DEFINE isend	PORTA,4
#DEFINE rstx	PORTB,0
#DEFINE rsrx	PORTB,1
#DEFINE beep	PORTB,3
#DEFINE sclk	PORTB,4
#DEFINE sdta	PORTB,5
;------------------------------------------------------------
;      cpu init
 	org	0x00
	goto	init
	org	0x04
;------------------------------------------------------------
init	call	usaex
	call	usbex
	movlw	0x00
	movwf	PORTA	
	movwf	PORTB	
	bsf	rstx
;------------------------------------------------------------
	call	halte
	call	halte
	call	halte
	call	halte
	call	halte
	call	halte
	bsf	beep
	call	halti
	call	halti
	bcf	beep
	call	atplus
	call	cpms ; selecteaza memorie telefon
	call	halte
;***************************************************
;	program principal
;***************************************************
goma	movlw	0x48	; cca. 5s delay
	movwf	count4
ko3	movlw	0xFF
	movwf	count1
ko2	movlw	0xFF	  
	movwf	count2
ko1	btfsc irec
	goto	rest
	nop
	nop
	nop
	nop
	decfsz	count2,F	
	goto 	ko1		
	decfsz	count1,F	
	goto 	ko2		
	decfsz	count4,F    
	goto  ko3          
	call	modem
	goto	goma	; se reia scanarea
;***************************************************
;	citeste telegrama instabus
;***************************************************
rest	movlw 0x03
	movwf count2
;******************
u2	btfss irec
	goto	u2
	call	haltb
	call	halta
	call	insrx
	call	halta ; 104 us for stop bit
	call	haltc	; 35 us - mai raman 222 us
	decfsz count2,F
	goto	u2
	movf	paru,0
	call	decode_tab	; intoarce adresa bruta a sms din eeprom
	movwf	eepadr1 ; adresa sms din eeprom
	movlw 0x05
	movwf count2
;***************************************************
u3	btfss irec
	goto	u3
	call	haltb
	call	halta
	call	insrx
	call	halta ; 104 us for stop bit
	call	haltc	; 35 us - mai raman 222 us
	decfsz count2,F
	goto	u3
	movlw	0x40	; verifica daca eepadr=0x40
	subwf	eepadr1,W
	btfss	STATUS,2 ;test zero bit
	goto	eoky	; daca e diferit
	movf	paru,0	; verifica daca on sau off
	andlw	0x0F 
	btfss	STATUS,2 ;test zero bit
	goto	alarm
	movlw 0x20
	addwf	eepadr1,F
	goto	alarm
eoky	call	halti	; adrese eeprom ok ; de trimis sms
	movlw	0x10	; verifica daca eepadr=0x10 
	subwf	eepadr1,W
	btfsc	STATUS,2 ;test zero bit
	goto	ho	; daca e egal
	nop
	movf	paru,0	; verifica daca on sau off
	andlw	0x0F 
	btfsc	STATUS,2 ;test zero bit
	goto	ho ; trimite sms doar pt. 81h
alarm	nop	; a fost obtinuta adresa din eeprom pt. sms
	bsf	beep
	call	atplus
	call	cmgs
	call	halti
	call	halti
	bcf	beep
	call	send_sms
;******************
ho	goto	goma
;***************************************************
;	citeste sms din telefon
;***************************************************
modem	call	atplus
	call	cmgr ; trimite comanda citire sms
	movlw 0x19
	movwf count3
cit	call	ser_rx
	call	halta
	decfsz	count3,F	
	goto 	cit
	movf	ratb,W
	movlw	0x0D
	subwf	ratb,W
	btfss	STATUS,2 ;test zero bit
	goto	gatas
	movlw 0x38
	movwf count3
cif	call	ser_rx
	call	halta
	decfsz	count3,F	
	goto 	cif
	rlf	ratb,1
	rlf	ratb,1
	rlf	ratb,1
	rlf	ratb,0
	andlw	0xF0
	movwf	eepadr1 ; adresa telegrama instabus din eeprom
	call	pttr	; trimite telegrama selectata pe instabus
	nop
	call	atplus	; sterge sms
	call	cmgd
	bsf	beep	; asteapta pana sterge mesajul sms
	call	halti
	call	halti
	call	halti
	call	halti
	bcf	beep
;**********************
gatas	bsf	beep
	call	halti
	call	halti
	call	halti
	call	halti
	bcf	beep
	retlw	0x00
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;
;
;
;
;
;
; 
;
;
;
;
;********************************************
;	sms to instabus 
; trimite telegrame de la eepadr1 pe instabus
;********************************************
pttr	movlw	0x01
	movwf	eepadr0 ; * adresa selectie eeprom/instabus pt.sms
	call	eeprom_ini
	movlw	0x09	
	movwf	count2
v1	btfsc irec	; verificare instabus liber
	goto	v1
	call	haltc
	btfsc irec
	goto	v1
	call	haltc
	btfsc irec
	goto	v1
	call	haltc
	btfsc irec
	goto	v1
	call	haltc
	btfsc irec
	goto	v1
	call	haltc
	btfsc irec
	goto	v1
	call	haltc
	btfsc irec
	call	haltc
	btfsc irec
	goto	v1
	call	haltc
	btfsc irec
rep	call	iic_rx
	movf	eprdta,0
	call	instx
	decfsz	count2,F	
	goto 	rep
	call	iic_rxu
	call	iic_stop
	call	halti
	return
;
;
;
;

;**********************************************************************
;	instabus to sms
; trimite sms de la adresa eepadr1
;**********************************************************************
send_sms
	movlw	0x00
	movwf	eepadr0 ; * adresa selectie eeprom/instabus pt.sms
	movlw	0x1F
	movwf	cnt1
	call	eeprom_ini
extr	call	iic_rx
	movf	eprdta,0
	movwf	clone
	rrf	clone,1
	rrf	clone,1
	rrf	clone,1
	rrf	clone,0
	andlw	0x0F
	call	ascii_tab
	call	ser_tx
	movf	eprdta,0
	andlw	0x0F
	call	ascii_tab
	call	ser_tx
	decfsz	cnt1,F	
	goto 	extr
	nop
	call	iic_rxu
	movf	eprdta,0
	andlw	0xF0
	call	ascii_tab
	call	ser_tx
	movf	eprdta,0
	andlw	0x0F
	call	ascii_tab
	call	ser_tx
	movlw	0x1A
	call	ser_tx
	call	iic_stop
	return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ascii_tab
	addwf	PCL,F
	retlw 0x30 ; 0
	retlw 0x31 ; 1
	retlw 0x32 ; 2
	retlw 0x33 ; 3
	retlw 0x34 ; 4
	retlw 0x35 ; 5
	retlw 0x36 ; 6
	retlw 0x37 ; 7
	retlw 0x38 ; 8
	retlw 0x39 ; 9
	retlw 0x41 ; A
	retlw 0x42 ; B
	retlw 0x43 ; C
	retlw 0x44 ; D
	retlw 0x45 ; E
	retlw 0x46 ; F
;***************************************************
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
decode_tab
	addwf	PCL,F
	retlw 0x10 ; 0 filtru
	retlw 0x10 ; 1 filtru
	retlw 0x00 ; 2
	retlw 0x10 ; 3 filtru
	retlw 0x20 ; 4
	retlw 0x10 ; 5 filtru
	retlw 0x10 ; 6 filtru
	retlw 0x10 ; 7 filtru
	retlw 0x40 ; 8
	retlw 0x10 ; 9 filtru
	retlw 0x80 ; A
	retlw 0xA0 ; B
	retlw 0x10 ; C filtru
	retlw 0x10 ; D filtru
	retlw 0x10 ; E filtru
	retlw 0x10 ; F filtru
;***************************************************
;***************************************************
atplus
	movlw	0x41
	call	ser_tx
	movlw	0x54
	call	ser_tx
	movlw	0x2B
	call	ser_tx
	retlw	0x00
;***************************************************
cmgs	movlw	0x43
	call	ser_tx
	movlw	0x4D
	call	ser_tx
	movlw	0x47
	call	ser_tx
	movlw	0x53
	call	ser_tx
	movlw	0x3D
	call	ser_tx
	movlw	0x33
	call	ser_tx
	movlw	0x31
	call	ser_tx
	movlw	0x0D
	call	ser_tx
	retlw	0x00
;***************************************************
cmgr	movlw	0x43
	call	ser_tx
	movlw	0x4D
	call	ser_tx
	movlw	0x47
	call	ser_tx
	movlw	0x52
	call	ser_tx
	movlw	0x3D
	call	ser_tx
	movlw	0x31
	call	ser_tx
	movlw	0x0D
	call	ser_tx
	retlw	0x00
;***************************************************
cmgd	movlw	0x43
	call	ser_tx
	movlw	0x4D
	call	ser_tx
	movlw	0x47
	call	ser_tx
	movlw	0x44
	call	ser_tx
	movlw	0x3D
	call	ser_tx
	movlw	0x31
	call	ser_tx
	movlw	0x0D
	call	ser_tx
	retlw	0x00
;***************************************************
cpms	movlw	0x43 ; AT+CPMS="ME" selecteaza memorie telefon
	call	ser_tx
	movlw	0x50
	call	ser_tx
	movlw	0x4D
	call	ser_tx
	movlw	0x53
	call	ser_tx
	movlw	0x3D
	call	ser_tx
	movlw	0x22
	call	ser_tx
	movlw	0x4D
	call	ser_tx
	movlw	0x45
	call	ser_tx
	movlw	0x22
	call	ser_tx
	movlw	0x0D
	call	ser_tx
	retlw	0x00
;
;**********************************************************************
;	Subrutine de acces eeprom cu protocol iic		
;**********************************************************************
;======================================================================
; eepadr1= date intrare
;======================================================================
;
eeprom_ini
	call	iic_start	;  ini citire eeprom
	movlw	0xA0 ; iic eeprom write address
	call	iic_tx
	movf	eepadr0,0 ; adresa selectie zona eeprom sms/instabus
	call	iic_tx
	movf	eepadr1,0
	call	iic_tx
	call	iic_start
	movlw	0xA1 ; iic eeprom read address
	call	iic_tx
	call	usbin
	retlw	00
;======================================================================
;======================================================================
iic_rx
	movlw 0x08 ; iic data receive , eprdta= output, 102us
	movwf count5
esbit	bsf	sclk
	call	haltj ; 4.25u
	bcf	STATUS,C
	btfsc sdta
	bsf	STATUS,C	
	rlf	eprdta,F
	bcf	sclk
	call	haltj ; 4.25u
	decfsz count5,F
	goto	esbit
	call	ack_read ; 14.25u
	nop
	retlw	00
;======================================================================
iic_rxu
	movlw 0x08 ; iic data receive , eprdta= output
	movwf count5
exbit	bsf	sclk
	call	haltj
	bcf	STATUS,C
	btfsc sdta
	bsf	STATUS,C	
	rlf	eprdta,F
	bcf	sclk
	call	haltj
	decfsz count5,F
	goto	exbit
	call	usbin	; 15us ultimul octet citit
	call	haltj
	bsf	sclk	; one clock step for acknowledge (no read data)
	call	haltj
	bcf	sclk
	call	usbex
	bcf	sclk
	bcf	sdta
	retlw	00
;======================================================================
;======================================================================
iic_tx 
	movwf	transo	; iic data transmission, W= input, 45103us
	movlw 0x08
	movwf count4
erbit	bcf	sclk
	call	haltj
	bcf	sdta
	btfsc	transo,7	
	bsf	sdta
	nop
	bsf	sclk
	call	haltj
	bcf	sclk
	bcf	sdta
	rlf	transo,F
	decfsz count4,F
	goto	erbit
	call	ack_write	; 5015us
	retlw	00
;======================================================================
;======================================================================
iic_stop
	bcf	sdta	; stop condition module 12.25us
	nop
	bsf	sclk
	call	haltj
	bsf	sdta	; stop command
	call	haltj
	bcf	sclk
	retlw	00
;======================================================================
iic_start
	bsf	sdta	; start condition module 12us
	bsf	sclk
	call	haltj
	bcf	sdta	; start command
	call	haltj
	bcf	sclk
	retlw	00
;======================================================================
ack_write
	call	usbin	; 15.5us
	call	haltj
	bsf	sclk	; one clock step for acknowledge (no read data)
	call	halte
	bcf	sclk
	call	usbex
	bcf	sclk
	bcf	sdta
	retlw	00
;======================================================================
ack_read ; 14.25u
	call	usbex ; 2u
	bcf	sdta
	bsf	sclk	; one clock step for acknowledge (no read data)
	call	haltj
	bcf	sclk
	call	haltj
	call	usbin ; 2u
	retlw	00
;======================================================================
;**********************************************************************
;	Subrutine pentru protocol instabus		 			
;**********************************************************************
instx	bsf	enable
	movwf	ratb	; instabus data transmission 
	movwf	paru
	movlw	0x07	; parity bit calculator
	movwf	count3
	movlw	0x01
	andwf	paru,0
	movwf	bug
roata	rrf	paru,1
	movlw	0x01
	andwf	paru,0
	xorwf	bug,1
	decfsz count3,F
	goto	roata
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	movlw 0x08	; byte data transsmision
	movwf count4
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	call	unu			; start bit
gbit	btfsc	ratb,0	; data reverse flow	
	call	nul
	btfss	ratb,0
	call	unu
	rrf	ratb,F
	decfsz count4,F
	goto	gbit
	btfsc	bug,0	; parity bit	
	call	nul
	btfss	bug,0
	call	unu
	call	nul	; stop bit
	call	halta	; two waiting bits 102 read eeprom+104us
	bcf	enable
 	retlw	00
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
insrx	movlw 0x08
	movwf count3
rec	bcf	STATUS,C	
	btfss	irec	; data reverse flow
	bsf	STATUS,C	
	rrf	paru,F
	call	halta	; 104 us
	decfsz count3,F
	goto	rec
 	retlw	00
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
unu	bsf	isend
	call	haltc
	bcf	isend
	call	haltd
 	retlw	00
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
nul	call	halta
 	retlw	00
;**********************************************************************
;	Subrutine protocol serial			 			
;**********************************************************************
ser_rx
	btfsc rsrx
	goto	ser_rx
	call	haltb
	movlw 0x08
	movwf count5
wdh2	call	halta
	bcf	STATUS,C
	btfsc rsrx
	bsf	STATUS,C	
	rrf	ratb,F
	decfsz count5,F
	goto	wdh2
	return
;**********************************************************************
ser_tx
	movwf	transo
	movlw	0x08	
	movwf	count4
	call	ein	; Start bit
wdh4	btfsc	transo,0
	call	null
	btfss	transo,0
	call	ein
	rrf	transo,F
	decfsz	count4,F	
	goto 	wdh4
	call	null	; Stop bit
	retlw	00
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ein	bcf	rstx
	call	halta
 	retlw	00
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
null	bsf	rstx
	call	halta
 	retlw	00
;**********************************************************************
;	Subrutine de intarziere				 			
;**********************************************************************
halta	movlw	0x88	; 136*3 step or 104us
	movwf	count1
q0	decfsz	count1,F	
	goto 	q0		
 	retlw	00
;______________________________________________________________________
haltb	movlw	0x16	; 22*3 pasi sau 17.75us
	movwf	count1
q1	decfsz	count1,F	
	goto 	q1		
 	retlw	00
;______________________________________________________________________
haltc	movlw	0x2D	; 45*3 pasi sau 35us
	movwf	count1
q2	decfsz	count1,F	
	goto 	q2		
 	retlw	00
;______________________________________________________________________
haltd	movlw	0x59	; 89*3 step or 68us
	movwf	count1
q3	decfsz	count1,F	
	goto 	q3
	nop
	nop		
 	retlw	00
;______________________________________________________________________
haltj	movlw	0x04	; 5*3 pasi sau 4.25us
	movwf	count1
q6	decfsz	count1,F	
	goto 	q6
 	retlw	00
;______________________________________________________________________
halte	movlw	0x48	; cca. 585ms delay
	movwf	count4
j3	movlw	0xFF
	movwf	count1
j1	movlw	0xFF	  
	movwf	count2
j2	decfsz	count2,F	
	goto 	j2		
	decfsz	count1,F	
	goto 	j1		
	decfsz	count4,F    
	goto  j3          
	retlw	00
;______________________________________________________________________
halti	movlw	0x40	; cca. 10ms delay
	movwf	count1
rot1	movlw	0xF0	  
	movwf	count2
rot2	decfsz	count2,F	
	goto 	rot2		
	decfsz	count1,F	
	goto 	rot1		
    	retlw	00
;**********************************************************************
;**********************************************************************
;::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
usaex	bsf	STATUS,RP0  ;switch to bank 1
	movlw	0x04	; PORTA set to out/inputs
	movwf	TRISA
	bcf	STATUS,RP0  ;switch back to bank 0
	return
;::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
usain	bsf	STATUS,RP0  ;switch to bank 1
	movlw	0x05	; sdta set to input
	movwf	TRISA
	bcf	STATUS,RP0  ;switch back to bank 0
	return
;::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
usbex	bsf	STATUS,RP0  ;switch to bank 1
	movlw	0x02	; PORTB set to out/inputs
	movwf	TRISB
	bcf	STATUS,RP0  ;switch back to bank 0
	return	;2 us
;::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
usbin	bsf	STATUS,RP0  ;switch to bank 1
	movlw	0xA2	; PORTB set to out/inputs
	movwf	TRISB
	bcf	STATUS,RP0  ;switch back to bank 0
	return
;::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;------------------------------------------------------------
	end
;============================================================
